//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%3A7EC5390120.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%3A7EC5390120.cm

//## begin module%3A7EC5390120.cp preserve=no
//## end module%3A7EC5390120.cp

//## Module: FitMethod%3A7EC5390120; Package body
//## Subsystem: XSFit::Fit%3677C9158350
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSFit/Fit/FitMethod.cxx

//## begin module%3A7EC5390120.additionalIncludes preserve=no
//## end module%3A7EC5390120.additionalIncludes

//## begin module%3A7EC5390120.includes preserve=yes
//## end module%3A7EC5390120.includes

// FitMethod
#include <XSFit/Fit/FitMethod.h>
//## begin module%3A7EC5390120.declarations preserve=no
//## end module%3A7EC5390120.declarations

//## begin module%3A7EC5390120.additionalDeclarations preserve=yes
#include <xsTypes.h>
#include <XSFit/Fit/Fit.h>
#include <XSUtil/Parse/XSparse.h>
#include <XSstreams.h>
#include <sstream>
#include <cmath>
#include <iomanip>
#include <map>
//## end module%3A7EC5390120.additionalDeclarations


// Class FitMethod::FitError 

FitMethod::FitError::FitError (int errCode, int paramNumber)
  //## begin FitMethod::FitError::FitError%3C87944B0256.hasinit preserve=yes
    : YellowAlert(" Fit algorithm returned error: ")
  //## end FitMethod::FitError::FitError%3C87944B0256.hasinit
  //## begin FitMethod::FitError::FitError%3C87944B0256.initialization preserve=yes
  //## end FitMethod::FitError::FitError%3C87944B0256.initialization
{
  //## begin FitMethod::FitError::FitError%3C87944B0256.body preserve=yes
  //## end FitMethod::FitError::FitError%3C87944B0256.body
}


// Class FitMethod 

//## begin FitMethod::fitMethodObjs%467A93590309.attr preserve=no  private: static std::set<FitMethod*> {U} 
std::set<FitMethod*> FitMethod::s_fitMethodObjs;
//## end FitMethod::fitMethodObjs%467A93590309.attr

//## begin FitMethod::subMethods%467A93E903A1.attr preserve=no  private: static std::map<string,FitMethod*> {U} 
std::map<string,FitMethod*> FitMethod::s_subMethods;
//## end FitMethod::subMethods%467A93E903A1.attr

FitMethod::FitMethod(const FitMethod &right)
  //## begin FitMethod::FitMethod%3A7EC4580119_copy.hasinit preserve=yes
  : m_secondDerivativeRequired(right.m_secondDerivativeRequired),
    m_pegsParameters(right.m_pegsParameters),
    m_firstDerivativeRequired(right.m_firstDerivativeRequired),
    m_deltaCrit(right.m_deltaCrit),
    m_numberOfTrials(right.m_numberOfTrials),
    m_selectedSubMethod(right.m_selectedSubMethod),
    m_evalue(right.m_evalue),
    m_evector(right.m_evector),
    m_covariance(right.m_covariance)
  //## end FitMethod::FitMethod%3A7EC4580119_copy.hasinit
  //## begin FitMethod::FitMethod%3A7EC4580119_copy.initialization preserve=yes
  //## end FitMethod::FitMethod%3A7EC4580119_copy.initialization
{
  //## begin FitMethod::FitMethod%3A7EC4580119_copy.body preserve=yes
  //## end FitMethod::FitMethod%3A7EC4580119_copy.body
}

FitMethod::FitMethod (const std::string& initString)
  //## begin FitMethod::FitMethod%3A7EC4A60306.hasinit preserve=yes
  : m_secondDerivativeRequired(false),
    m_pegsParameters(false),
    m_firstDerivativeRequired(false),
    m_deltaCrit(.01),
    m_numberOfTrials(10),
    m_selectedSubMethod(),
    m_evalue(),
    m_evector(),
    m_covariance()
  //## end FitMethod::FitMethod%3A7EC4A60306.hasinit
  //## begin FitMethod::FitMethod%3A7EC4A60306.initialization preserve=yes
  //## end FitMethod::FitMethod%3A7EC4A60306.initialization
{
  //## begin FitMethod::FitMethod%3A7EC4A60306.body preserve=yes
   StringArray params;
   IntegerArray iParams;
   XSparse::collateByWhitespace(params, initString);
   // We control initString and it shouldn't contain commas. 
   // Also note that param 1 (0-based) should be nTrials. 
   // Therefore for iParams...
   for (int i=0; i<params.size(); ++i)
      iParams.push_back(i+1);
   // This can throw.
   processMethodString(iParams, params);
  //## end FitMethod::FitMethod%3A7EC4A60306.body
}


FitMethod::~FitMethod()
{
  //## begin FitMethod::~FitMethod%3A7EC4580119_dest.body preserve=yes
  //## end FitMethod::~FitMethod%3A7EC4580119_dest.body
}


FitMethod & FitMethod::operator=(const FitMethod &right)
{
  //## begin FitMethod::operator=%3A7EC4580119_assign.body preserve=yes
  if ( this != &right) copy(right);
  return *this;
  //## end FitMethod::operator=%3A7EC4580119_assign.body
}



//## Other Operations (implementation)
FitMethod* FitMethod::get (const std::string& name)
{
  //## begin FitMethod::get%3B7AC1E8024A.body preserve=yes
  FitMethod* selectedObj = 0;
  string lcName(XSutility::lowerCase(name));
  std::map<std::string,FitMethod*>::const_iterator itSubMethod = 
                s_subMethods.lower_bound(lcName);
  std::map<std::string,FitMethod*>::const_iterator itSubMethodEnd = 
                s_subMethods.end();
  if (itSubMethod != itSubMethodEnd && itSubMethod->first.find(lcName)==0)
  {
     selectedObj = itSubMethod->second->clone();
     selectedObj->m_selectedSubMethod = itSubMethod->first;
  }
  return selectedObj;
  //## end FitMethod::get%3B7AC1E8024A.body
}

void FitMethod::secondDerivativeRequired (bool value)
{
  //## begin FitMethod::secondDerivativeRequired%3B7AE1F40000.body preserve=yes
  m_secondDerivativeRequired = value;
  //## end FitMethod::secondDerivativeRequired%3B7AE1F40000.body
}

void FitMethod::firstDerivativeRequired (bool value)
{
  //## begin FitMethod::firstDerivativeRequired%3B7AE22101D4.body preserve=yes
  m_firstDerivativeRequired = value;
  //## end FitMethod::firstDerivativeRequired%3B7AE22101D4.body
}

void FitMethod::registerMethod (const string& name, FitMethod* method)
{
  //## begin FitMethod::registerMethod%3BFABD5201B5.body preserve=yes
  s_subMethods[name] = method;
  if (s_fitMethodObjs.find(method) == s_fitMethodObjs.end())
     s_fitMethodObjs.insert(method);
  //## end FitMethod::registerMethod%3BFABD5201B5.body
}

void FitMethod::processMethodString (const IntegerArray& iParams, const StringArray& params)
{
  //## begin FitMethod::processMethodString%3C1A705401EB.body preserve=yes
  using namespace std;
   
   int testNTrials = m_numberOfTrials;
   Real testDeltaCrit = m_deltaCrit;
   for (size_t i=0; i<iParams.size(); ++i)
   {
      istringstream testIss(params[i]);
      // Assume param 0 has been handled prior to entering this function.
      if (iParams[i] == 1)
      {
         if (!(testIss >> testNTrials) || !testIss.eof() || testNTrials <= 0)
         {
            throw YellowAlert("Improper nTrials value.\n");
         }
      }
      else if (iParams[i] == 2)
      {
         if (!(testIss >> testDeltaCrit) || !testIss.eof() || testDeltaCrit <= .0)
         {
            throw YellowAlert("Improper critical delta value.\n");
         }
      }
   }
   // In case FitMethod subclass requires any further argument processing:
   processMethodStringExtras(iParams, params);
   
   m_numberOfTrials = testNTrials;
   m_deltaCrit = testDeltaCrit;
   // If this is not the original prototype, then update prototype. 
   map<string,FitMethod*>::iterator itProto = s_subMethods.find(m_selectedSubMethod);
   if (itProto != s_subMethods.end())
   {
      itProto->second->m_numberOfTrials = m_numberOfTrials;
      itProto->second->m_deltaCrit = m_deltaCrit;  
   }
  //## end FitMethod::processMethodString%3C1A705401EB.body
}

string FitMethod::fitNames ()
{
  //## begin FitMethod::fitNames%3C83B98D03D1.body preserve=yes
  std::map<string,FitMethod*>::const_iterator itFm = s_subMethods.begin();
  std::map<string,FitMethod*>::const_iterator itFmEnd = s_subMethods.end();
  string names;
  while ( itFm != itFmEnd)
  {
          names += itFm->first;
          ++itFm;       
          if (itFm != itFmEnd) names += " | ";
          else names += " ";
  }
        
  return names;      
  //## end FitMethod::fitNames%3C83B98D03D1.body
}

void FitMethod::swap (FitMethod& right)
{
  //## begin FitMethod::swap%3C84F0EC0131.body preserve=yes
    std::swap(m_secondDerivativeRequired,right.m_secondDerivativeRequired);
    std::swap(m_pegsParameters,right.m_pegsParameters);
    std::swap(m_firstDerivativeRequired,right.m_firstDerivativeRequired);
    std::swap(m_deltaCrit,right.m_deltaCrit);
    std::swap(m_numberOfTrials,right.m_numberOfTrials);
    std::swap(m_evalue,right.m_evalue);
    std::swap(m_evector,right.m_evector);
    std::swap(m_covariance,right.m_covariance);
    std::swap(m_selectedSubMethod,right.m_selectedSubMethod);
  //## end FitMethod::swap%3C84F0EC0131.body
}

void FitMethod::reportProgress (std::ostream& s, Fit* fit) const
{
  //## begin FitMethod::reportProgress%3C8E315A0318.body preserve=yes
  //## end FitMethod::reportProgress%3C8E315A0318.body
}

void FitMethod::perform (Fit* fit)
{
  //## begin FitMethod::perform%3D52950E0187.body preserve=yes
  
  doPerform(fit);
  fit->isStillValid(true);
  
  //## end FitMethod::perform%3D52950E0187.body
}

const RealArray& FitMethod::evalue () const
{
  //## begin FitMethod::evalue%3F1C287F0321.body preserve=yes
  return m_evalue;
  //## end FitMethod::evalue%3F1C287F0321.body
}

const RealArray& FitMethod::evector () const
{
  //## begin FitMethod::evector%3F1C28BC013E.body preserve=yes
  return m_evector;
  //## end FitMethod::evector%3F1C28BC013E.body
}

bool FitMethod::getErrors (Fit* fit, const string& modelName, const IntegerArray& paramNums)
{
  //## begin FitMethod::getErrors%41A36E320295.body preserve=yes
  return false;
  //## end FitMethod::getErrors%41A36E320295.body
}

const RealArray& FitMethod::covariance () const
{
  //## begin FitMethod::covariance%41A3B94803E2.body preserve=yes
  return m_covariance;
  //## end FitMethod::covariance%41A3B94803E2.body
}

void FitMethod::reportCovariance () const
{
  //## begin FitMethod::reportCovariance%41A3B98502D7.body preserve=yes
  using namespace std;
  if (m_covariance.size())
  {
     const int WIDTH(12);
     ios_base::fmtflags saveFlags(tcout.flags());
     int savePrecision(tcout.precision());
     tcout << scientific << setprecision(3) << left;
     // This just assumes m_covariance is of size nPar*nPar. 
     size_t nPar = static_cast<size_t>(sqrt(static_cast<Real>(m_covariance.size())));
     string topBar(nPar*WIDTH, '=');
     string bottomBar(nPar*WIDTH, '-');
     tcout << endl << topBar << endl;
     tcout << "  Covariance Matrix" << endl;
     for (size_t j=1; j<=nPar; ++j)
     {
        tcout << "   " << setw(WIDTH-3) << j;
     }
     tcout << endl;
     for (size_t i=0; i<nPar; ++i)
     {
        for (size_t j=0; j<nPar; ++j)
        {
           tcout << setw(WIDTH) << m_covariance[i*nPar + j];
        }
        tcout << endl;
     }
     tcout << bottomBar << endl;
     tcout.flags(saveFlags);
     tcout.precision(savePrecision);
  }
  
  //## end FitMethod::reportCovariance%41A3B98502D7.body
}

void FitMethod::clearMethods ()
{
  //## begin FitMethod::clearMethods%429F4E8201E9.body preserve=yes
   std::set<FitMethod*>::iterator itFm = s_fitMethodObjs.begin();
   std::set<FitMethod*>::iterator itEnd = s_fitMethodObjs.end();
   while (itFm != itEnd)
   {
      delete *itFm;
      ++itFm;
   }
   s_fitMethodObjs.clear();
  //## end FitMethod::clearMethods%429F4E8201E9.body
}

void FitMethod::processMethodStringExtras (const IntegerArray& iParams, const StringArray& params)
{
  //## begin FitMethod::processMethodStringExtras%4342BB9C02C2.body preserve=yes
  //## end FitMethod::processMethodStringExtras%4342BB9C02C2.body
}

void FitMethod::improve (Fit* fit)
{
  //## begin FitMethod::improve%467A96B402BC.body preserve=yes
   throw YellowAlert("Improve command is only implemented for Minuit methods.\n");
  //## end FitMethod::improve%467A96B402BC.body
}

// Additional Declarations
  //## begin FitMethod%3A7EC4580119.declarations preserve=yes
  //## end FitMethod%3A7EC4580119.declarations

//## begin module%3A7EC5390120.epilog preserve=yes
//## end module%3A7EC5390120.epilog
